package com.company;

import java.util.ArrayList;
import java.util.Iterator;

public class Player {
    // List of player's cards
    private ArrayList<Card> playerCards = new ArrayList<>();
    // point of the player
    private int playerPoint;

    ArrayList<Card> possibleCards;

    /**
     * returns the list of player's cards
     * @return the list of player's cards
     */
    public ArrayList<Card> getPlayerCards() {
        return playerCards;
    }

    /**
     *
     * @param playerNumber
     */
    public void printAllCards(int playerNumber){
        System.out.println("Player" + playerNumber + ":");
        Iterator<Card> cardIterator = playerCards.iterator();
        while (cardIterator.hasNext()){
            Card c = cardIterator.next();
            System.out.println(c.toString());
        }
    }

    public int getPlayerPoint() {
        Iterator<Card> cardIterator = playerCards.iterator();
        while (cardIterator.hasNext()){
            playerPoint += cardIterator.next().getCardPoint();
        }
        return playerPoint;
    }

    public void checkAllCards(Card card){
        possibleCards = new ArrayList<>();
        boolean isColored;
        if (card instanceof Colored)
            isColored = true;
        else
            isColored = false;
        Iterator<Card> cardIterator = playerCards.iterator();
        while (cardIterator.hasNext()){
            Card c = cardIterator.next();
            if (c instanceof Colored) {
                if (isColored)
                    if (((Colored) c).checkEquality((Colored) card))
                        possibleCards.add(c);
            }
            else
                possibleCards.add(c);
        }
        if (possibleCards.size() > 0) {
            if (possibleCards.size() != searchWildDraws())
                deleteWildDraws();
        }
    }

    public int searchWildDraws(){
        int counterWildDraw = 0;
       Iterator<Card> cardIterator = possibleCards.iterator();
       while (cardIterator.hasNext()){
           Card c = cardIterator.next();
           if (c instanceof WildDraw)
               counterWildDraw++;
       }
       return counterWildDraw;
    }

    public void deleteWildDraws(){
        Iterator<Card> cardIterator = possibleCards.iterator();
        while (cardIterator.hasNext()) {
            Card c = cardIterator.next();
            if (c instanceof WildDraw)
                possibleCards.remove(c);
        }
    }

    public void whichCard(Card card){

    }

    public String toString(int playerNumber) {
        return "Player" + playerNumber +
                " {playerPoint=" + playerPoint +
                " }";
    }
}
